/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class PUNKT {\n    int x = 8;\n    int y = 2;\n    String name;\n    \n    // Eine Methode:\n    void printKoordinaten() {\n        String s;\n        s = this.x + '|' + this.y;\n        println('(' + s + ')');\n    }\n    \n    // Weitere Methode:\n    void printAngabe() {\n        print(this.name);\n        this.printKoordinaten();\n    }\n}\n\n// Ab jetzt: Das „Hauptprogramm“\nPUNKT P1 = new PUNKT();\nP1.name = \"X\";\nP1.printKoordinaten();\nPUNKT P2 = P1;\nP1 = new PUNKT();\nP1.name = \"Y\";\nP1.x = 1;\nprintln(\"\");\nP1.printAngabe();\nP2.printAngabe();",
	"classes": [
		{
			"className": "PUNKT",
			"atts": [
				{
					"key": "x",
					"type": "int",
					"value": 8
				},
				{
					"key": "y",
					"type": "int",
					"value": 2
				},
				{
					"key": "name",
					"type": "String",
					"value": ""
				}
			],
			"abstract": true
		}
	],
	"notSelectable": [
		4,
		5,
		10,
		11,
		12,
		16,
		17,
		18,
		19
	],
	"methodCalls": [
		6,
		13
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "PUNKT"
		}
	],
	"steps": [
		{
			"line": -1,
			"vars": {
				"instances": [],
				"vars": [],
				"scopes": []
			},
			"enableTextOut": true,
			"autoremoveGarbage": true,
			"task": "<p>Zusätzlich zur Deklaration der Attribute werden in dieser Klassendefinition auch die Methoden <code>printKoordinaten()</code> und <code>printAngabe()</code> definiert. Wie Methodenaufrufe ablaufen, wird hier schrittweise erklärt.</p><p>Bereit? Wähle nun die erste Anweisung im „Hauptprogramm“ nach der Klassendefinition aus!</p>"
		},
		{
			"task": "Die Objekterzeugung funktioniert wie gewohnt. Achte aber darauf, beim Erzeugen des Objektes alle Methodendeklarationen zu überspringen!",
			"line": 20,
			"vars": []
		},
		{
			"task": "Die Objekterzeugung funktioniert wie gewohnt. Achte aber darauf, alle Methodendeklarationen zu überspringen!",
			"line": 0,
			"vars": [
				{
					"key": "P1",
					"type": "PUNKT",
					"ref": null
				}
			]
		},
		{
			"line": 1,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 20,
						"vars": []
					}
				]
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 20,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 3,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 20,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							}
						]
					}
				]
			}
		},
		{
			"task": "Das ist nur eine Wertezuweisung in Punktnotation.",
			"line": 21,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Hier siehst du ein Beispiel für einen Methodenaufruf: Suche die passende Methodendefinition und klicke dort auf <em>Aufrufen</em>.",
			"line": 22,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "In einer Methode zeigt <code>this</code> auf das Objekt, dessen Methode aufgerufen wurde. Setze nun seinen Wert auf die Speicheradresse des Objektes, bevor du mit der ersten Anweisung der Methodensequenz startest.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Innerhalb der Methode deklarierte Variablen sind nur dort verfügbar.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 22,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"task": "Da <code>this</code> auf das aktuelle Objekt zeigt, sind dessen Attributwerte nutzbar: Z. B. <code>this.x</code> ist also das Attribut <code>x</code> des Objektes.",
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 22,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "Natürlich kann auch eine Methode Text auf die Textausgabe schreiben. Führe nun diese letzte Anweisung der Methode aus und schließe den Methodenaufruf dann ab, indem du beim Speichertabellen-Eintrag für den Methodenaufruf auf ❌ klickst. Dadurch springst du auch automatisch dahin zurück, von wo der Methodenaufruf ausgelöst wurde. Wähle dann die nächste Anweisung in der Sequenz aus.",
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 22,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "8|2"
							}
						]
					}
				]
			}
		},
		{
			"task": "Das ist nur eine einfache Variablendeklaration kombiniert mit einer Wertezuweisung.",
			"line": 23,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "(8|2)\n"
		},
		{
			"task": "Erzeuge wieder ein Objekt und vergiss nicht, am Ende die Speicheradresse der Variable <code>P1</code> zuzuweisen.",
			"line": 24,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 0,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 1,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 24,
						"vars": []
					}
				]
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 24,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							}
						]
					}
				]
			}
		},
		{
			"line": 3,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": "PUNKT",
						"line": 24,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							}
						]
					}
				]
			}
		},
		{
			"task": "Arbeite diese Anweisung (wie gewohnt) ab.",
			"line": 25,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 26,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 27,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Jetzt ein Aufruf der Methode <code>printAngabe()</code> vom Objekt, auf das <code>P1</code> zeigt. Starte den Methodenaufruf durch Anklicken der Schaltfläche bei der Methodendefinition.",
			"line": 28,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "(8|2)\n\n"
		},
		{
			"task": "Wieder besonders wichtig: Setze <code>this</code> auf den richtigen Wert.",
			"line": 13,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"task": "Führe diese normale Anweisung aus.",
			"line": 14,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					}
				]
			}
		},
		{
			"task": "Auch eine Methode kann eine Methode aufrufen. Klicke dazu wieder auf die Schaltfläche zur Methodendefinition.",
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					}
				]
			},
			"cout": "(8|2)\n\nY"
		},
		{
			"task": "Nicht vergessen: Setze den Wert von <code>this</code> dieses Methodenaufrufs auf den Wert von <code>this</code> des bisherigen Methodenaufrufs.",
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					}
				]
			}
		},
		{
			"task": "Arbeite nun diese Anweisung ab.",
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					}
				]
			}
		},
		{
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 12
							},
							{
								"key": "s",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "Arbeite nun die letzte Anweisung ab und schließe den Methodenaufruf ab. Damit ist auch die Methode <code>printAngabe</code> fertig abgearbeitet und kann abgeschlossen werden.",
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 28,
						"vars": [
							{
								"key": "this",
								"ref": 12
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 12
							},
							{
								"key": "s",
								"type": "String",
								"value": "1|2"
							}
						]
					}
				]
			}
		},
		{
			"task": "Jetzt noch Dasselbe für das andere Objekt.",
			"line": 29,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "(8|2)\n\nY(1|2)\n"
		},
		{
			"line": 13,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 14,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			},
			"cout": "(8|2)\n\nY(1|2)\nX"
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			}
		},
		{
			"line": 8,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"task": "Schließe nun beide Methodenaufrufe ab.",
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 29,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					},
					{
						"className": null,
						"line": 15,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "8|2"
							}
						]
					}
				]
			}
		},
		{
			"task": "Geschafft!",
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 8
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "X"
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 1
							},
							{
								"key": "y",
								"type": "int",
								"value": 2
							},
							{
								"key": "name",
								"type": "String",
								"value": "Y"
							}
						],
						"pointer": 12
					}
				],
				"vars": [
					{
						"key": "P1",
						"type": "PUNKT",
						"ref": 12
					},
					{
						"key": "P2",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "(8|2)\n\nY(1|2)\nX(8|2)\n"
		}
	]
};
